aboutsummaryrefslogtreecommitdiff
path: root/support/scripts
diff options
context:
space:
mode:
authorGravatar Yann E. MORIN <yann.morin.1998@free.fr>2015-03-24 23:16:48 +0100
committerGravatar Thomas Petazzoni <thomas.petazzoni@free-electrons.com>2015-03-31 23:50:11 +0200
commit5558a34e9ab8d53b4dafe3f760bff26d2df9c154 (patch)
treed4e0ff9f2c0a10bfa240c30d15da0957cbce4743 /support/scripts
parente90e98f951a40660dddafa44414f027bb5b43f85 (diff)
downloadbuildroot-5558a34e9ab8d53b4dafe3f760bff26d2df9c154.tar.gz
buildroot-5558a34e9ab8d53b4dafe3f760bff26d2df9c154.tar.bz2
support/graph-depends: add option to stop on specific packages
Add a new option to graph-depends, that users can set to stop the graph on a specific (set of) package(s). This accepts any actual package name, or the 'virtual' keyword to stop on virtual packages. Signed-off-by: "Yann E. MORIN" <yann.morin.1998@free.fr> Cc: Thomas Petazzoni <thomas.petazzoni@free-electrons.com> Cc: Francois Perrad <fperrad@gmail.com> Reviewed-by: Samuel Martin <s.martin49@gmail.com> Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
Diffstat (limited to 'support/scripts')
-rwxr-xr-xsupport/scripts/graph-depends14
1 files changed, 13 insertions, 1 deletions
diff --git a/support/scripts/graph-depends b/support/scripts/graph-depends
index 5b9b195469..93844c7fb3 100755
--- a/support/scripts/graph-depends
+++ b/support/scripts/graph-depends
@@ -36,11 +36,14 @@ max_depth = 0
# Whether to draw the transitive dependencies
transitive = True
-parser = argparse.ArgumentParser(description="Graph pacakges dependencies")
+parser = argparse.ArgumentParser(description="Graph packages dependencies")
parser.add_argument("--package", '-p', metavar="PACKAGE",
help="Graph the dependencies of PACKAGE")
parser.add_argument("--depth", '-d', metavar="DEPTH", dest="depth", type=int, default=0,
help="Limit the dependency graph to DEPTH levels; 0 means no limit.")
+parser.add_argument("--stop-on", "-s", metavar="PACKAGE", dest="stop_list", action="append",
+ help="Do not graph past this package (can be given multiple times)." \
+ + " 'virtual' to stop on virtual packages.")
parser.add_argument("--colours", "-c", metavar="COLOR_LIST", dest="colours",
default="lightblue,grey,gainsboro",
help="Comma-separated list of the three colours to use" \
@@ -61,6 +64,11 @@ else:
max_depth = args.depth
+if args.stop_list is None:
+ stop_list = []
+else:
+ stop_list = args.stop_list
+
transitive = args.transitive
# Get the colours: we need exactly three colours,
@@ -304,6 +312,10 @@ def print_pkg_deps(depth, pkg):
print_attrs(pkg)
if pkg not in dict_deps:
return
+ if pkg in stop_list:
+ return
+ if dict_version.get(pkg) == "virtual" and "virtual" in stop_list:
+ return
if max_depth == 0 or depth < max_depth:
for d in dict_deps[pkg]:
print("%s -> %s" % (pkg_node_name(pkg), pkg_node_name(d)))